﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace XMLVerify {
    /// <summary>
    /// Interaction logic for FOptionen.xaml
    /// </summary>
    public partial class FOptionen : Window {
        private Boolean result = false;

        public Boolean Result {
            get { return result; }
        }

        private int fontcolorRed = 0;
        private int fontcolorGreen = 0;
        private int fontcolorBlue = 0;

        private int bgcolorRed = 255;
        private int bgcolorGreen = 255;
        private int bgcolorBlue = 255;

        public FOptionen(Window parent) {
            // WindowStartupLocation="CenterOwner"
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner; // nur in XAML
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            SingVar singvar = SingVar.getInstance();
            chkWordWrap.IsChecked = singvar.WordWrap;
            chkFormatTab.IsChecked = singvar.FormatTab;

            fontcolorRed = singvar.FontcolorRed;
            fontcolorGreen = singvar.FontcolorGreen;
            fontcolorBlue = singvar.FontcolorBlue;

            bgcolorRed = singvar.BGcolorRed;
            bgcolorGreen = singvar.BGcolorGreen;
            bgcolorBlue = singvar.BGcolorBlue;
            setColors();

        }



        private void setColors() {
            tForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue));
            // Color.FromRgb((byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue);
            tBackground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)bgcolorRed, (byte)bgcolorGreen, (byte)bgcolorBlue));
            tTestBox.Foreground = new SolidColorBrush(Color.FromArgb((byte)255, (byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue));
            tTestBox.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)bgcolorRed, (byte)bgcolorGreen, (byte)bgcolorBlue));
        }


        private void bnselectForeground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(fontcolorRed, fontcolorGreen, fontcolorBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                fontcolorRed = dialog.Red;
                fontcolorGreen = dialog.Green;
                fontcolorBlue = dialog.Blue;
                setColors();
            }
        }

        private void bnselectBackground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(bgcolorRed, bgcolorGreen, bgcolorBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                bgcolorRed = dialog.Red;
                bgcolorGreen = dialog.Green;
                bgcolorBlue = dialog.Blue;
                setColors();
            }
        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            SingVar singvar = SingVar.getInstance();
            singvar.WordWrap = chkWordWrap.IsChecked == true;
            singvar.FormatTab = chkFormatTab.IsChecked == true;

            singvar.FontcolorRed = fontcolorRed;
            singvar.FontcolorGreen = fontcolorGreen;
            singvar.FontcolorBlue = fontcolorBlue;

            singvar.BGcolorRed = bgcolorRed;
            singvar.BGcolorGreen = bgcolorGreen;
            singvar.BGcolorBlue = bgcolorBlue;

            result = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }
    }
}
