﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections;

using System.IO;
using System.Windows;

namespace XMLVerify
{
    class SingVar
    {
        public static string C_REG_ADR = "SOFTWARE\\WILHELM\\XMLVerifier";

        public static String C_NONAME = "noname";

        public static List<String> fileliste = new List<string>();


        private static void readFilelist() {
            SingVar.fileliste.Clear();            
            int n = Basis.ReadRegInt(SingVar.C_REG_ADR, "countfiles");
            for (int i = 0; i < n; i++) {
                String filename = Basis.ReadRegString(SingVar.C_REG_ADR, "file" + (i + 1));
                if (File.Exists(filename)) {
                    SingVar.fileliste.Add(filename);
                }
            } // for 
        }

        public static void insertIntoFilelist(String filename) {
            foreach (String filenameLoop in SingVar.fileliste) {
                if (filenameLoop.ToLower().Equals(filename.ToLower())) {
                    return;
                }
            }
            SingVar.fileliste.Add(filename);
            writeFileliste2Registry();
        }

        // error am 2022/10/19
        public static void writeFileliste2Registry() {
            int n = 0;
            foreach (String filename in SingVar.fileliste) {
                if (File.Exists(filename)) {
                    n++;
                    Basis.WriteRegString(SingVar.C_REG_ADR, "file" + (n + 1),filename);
                }
            }
            Basis.WriteRegInt(SingVar.C_REG_ADR, "countfiles", n);
            //foreach (String filename in SingVar.fileliste) {
            //    if (File.Exists(filename)) {
            //        SingVar.fileliste.Add(filename);
            //    }
            //}
        }  // writeFileliste2Registry


        // instance muss nach C_REG_ADR kommen
        private static SingVar instance = new SingVar();

        // public ArrayList files = new ArrayList();


        private int iTabLength = 2;
        private bool bWordWrap = false;


        private int iTop = 0;
        private int iLeft = 0;
        private int iWidth = 800;
        private int iHeight = 600;
        private bool bSetting = false;
        private bool bFormatTab = true;


        public bool Setting
        {
            get { return bSetting; }
            set
            {
                bSetting = value;
                Basis.WriteRegBool(C_REG_ADR, "bSetting", bSetting);
            }
        }


        public bool FormatTab
        {
            get { return bFormatTab; }
            set
            {
                bFormatTab = value;
                Basis.WriteRegBool(C_REG_ADR, "bFormatTab", bFormatTab);
            }
        }


        public int TabLength
        {
            get { return iTabLength; }
            set
            {
                iTabLength = value;
                Basis.WriteRegInt(C_REG_ADR, "iTabLength", iTabLength);
            }
        }

        // ------------------



        public bool WordWrap
        {
            get { return bWordWrap; }
            set
            {
                bWordWrap = value;
                Basis.WriteRegBool(C_REG_ADR, "bWordWrap", bWordWrap);
            }
        }




        public int Top
        {
            get { return iTop; }
            set
            {
                iTop = value;
                Basis.WriteRegInt(C_REG_ADR, "iTop", iTop);
            }
        }


        public int Left
        {
            get { return iLeft; }
            set
            {
                iLeft = value;
                Basis.WriteRegInt(C_REG_ADR, "iLeft", iLeft);
            }
        }


        public int Width
        {
            get { return iWidth; }
            set
            {
                iWidth = value;
                Basis.WriteRegInt(C_REG_ADR, "iWidth", iWidth);
            }
        }


        public int Height
        {
            get { return iHeight; }
            set
            {
                iHeight = value;
                Basis.WriteRegInt(C_REG_ADR, "iHeight", iHeight);
            }
        }


        private int fontcolorRed = 0; // Color.Black;
        public int FontcolorRed {
            get { return fontcolorRed; }
            set {
                fontcolorRed = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorRed", fontcolorRed);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }

        private int fontcolorGreen = 0; // Color.Black;
        public int FontcolorGreen {
            get { return fontcolorGreen; }
            set {
                fontcolorGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorGreen", fontcolorGreen);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }

        private int fontcolorBlue = 0; // Color.Black;
        public int FontcolorBlue {
            get { return fontcolorBlue; }
            set {
                fontcolorBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorBlue", fontcolorBlue);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }




        private int bgcolorRed = 255;
        public int BGcolorRed {
            get { return bgcolorRed; }
            set {
                bgcolorRed = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorRed", bgcolorRed);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }

        private int bgcolorGreen = 255;
        public int BGcolorGreen {
            get { return bgcolorGreen; }
            set {
                bgcolorGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorGreen", bgcolorGreen);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }

        private int bgcolorBlue = 255;
        public int BGcolorBlue {
            get { return bgcolorBlue; }
            set {
                bgcolorBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorBlue", bgcolorBlue);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }

        // -----------





        public static SingVar getInstance()
        {
            return instance;
        }

        private SingVar()
        {
            iTabLength = Basis.ReadRegInt(C_REG_ADR, "iTabLength");
            if (iTabLength < 5) iTabLength = 5;

            bWordWrap = Basis.ReadRegBool(C_REG_ADR, "bWordWrap");
            bFormatTab = Basis.ReadRegBool(C_REG_ADR, "bFormatTab");

            bSetting = Basis.ReadRegBool(C_REG_ADR, "bSetting");
            iTop = Basis.ReadRegInt(C_REG_ADR, "iTop");
            iLeft = Basis.ReadRegInt(C_REG_ADR, "iLeft");
            iWidth = Basis.ReadRegInt(C_REG_ADR, "iWidth");
            iHeight = Basis.ReadRegInt(C_REG_ADR, "iHeight");

            if (Basis.ReadRegBool(C_REG_ADR, "isSetFontColor")) {
                fontcolorRed = Basis.ReadRegInt(C_REG_ADR, "fontcolorRed");
                fontcolorGreen = Basis.ReadRegInt(C_REG_ADR, "fontcolorGreen");
                fontcolorBlue = Basis.ReadRegInt(C_REG_ADR, "fontcolorBlue");
            }

            if (Basis.ReadRegBool(C_REG_ADR, "isSetBGColor")) {
                bgcolorRed = Basis.ReadRegInt(C_REG_ADR, "bgcolorRed");
                bgcolorGreen = Basis.ReadRegInt(C_REG_ADR, "bgcolorGreen");
                bgcolorBlue = Basis.ReadRegInt(C_REG_ADR, "bgcolorBlue");
            }

            readFilelist();

        }
    }
}
